<?php
class NP_SNSButton extends NucleusPlugin {

	function getName() {
		return 'SNSButton';
	}

	function getAuthor() {
		return 'kazmix';
	}

	function getURL() {
		return 'http://www.kazmix.com/';
	}

	function getVersion() {
		return '0.0.1';
	}

	function getDescription() {
		return 'output SNS Button.';
	}

	function supportsFeature($what) {
		switch ($what) {
			case 'SqlTablePrefix':
				return 1;
			default:
				return 0;
		}
	}

	function getEventList() {
		return array('PreItem');
	}

	function install() {
		$this->createOption ('sns_charset', "Global: Charset setting", 'select', 'utf-8', 'euc-jp|EUC-JP|utf-8|UTF-8');
		$this->createOption ('sns_title_separator', "Global: Separator between post title and blogname", 'text', ' | ', ' | ');
		$this->createOption ('tw_via',"Twitter: Screen name of the user to attribute the Tweet to",'text','','');
		$this->createOption ('tw_count',"Twitter: Tweet count box position",'select','none','none|none|horizontal|horizontal|vertical|vertical');
		$this->createOption ('tw_size',"Twitter: Tweet button size",'select','midium','midium|midium|large|large');
		$this->createOption ('tw_related',"Twitter: Related accounts",'text','','');
		$this->createOption ('tw_hashtags',"Twitter: Comma separated hashtags appended to tweet text",'text','','');
		$this->createOption ('fb_layout',"Facebook: Determines the size and amount of social context next to the button",'select','button_count','standard|standard|button_count|button_count|box_count|box_count');
		$this->createOption ('fb_width',"Facebook: The width of the Like button",'text','110','110');
		$this->createOption ('fb_action',"Facebook: The verb to display on the button",'select','like','like|like|recommend|recommend');
		$this->createOption ('fb_colorscheme',"Facebook: The color scheme for the like button",'select','light','light|light|dark|dark');
		$this->createOption ('hb_layout',"Hatena Bookmark: Button style",'select','simple-balloon','simple|simple|simple-balloon|simple-balloon|standard-balloon|standard-balloon|vertical-balloon|vertical-balloon');
		$this->createOption ('gp_size',"Google+: Button size",'select','medium','small|small|medium|medium|standard|standard|tall|tall');
		$this->createOption ('gp_annotation',"Google+: Button annotation",'select','bubble','inline|inline|bubble|bubble|none|none');
		$this->createOption ('gp_width',"Google+: Button width (effect with 'inline' only) ",'text','450','450');
	}

	function event_PreItem($data) {
		$this->currentItem = &$data["item"];
		$this->index_item_title = $this->currentItem->title;
		$this->index_itemid = $this->currentItem->itemid;
		$this->tw_data = 'data-count='.$this->getOption('tw_count');
		$this->tw_data .= $this->getOption('tw_via') == "" ? "":(' data-via="'.$this->getOption('tw_via').'"');
		$this->tw_data .= $this->getOption('tw_size') == "midium" ? "":(' data-size="'.$this->getOption('tw_size').'"');
		$this->tw_data .= $this->getOption('tw_related') == "" ? "":(' data-related="'.$this->getOption('tw_related').'"');
		$this->tw_data .= $this->getOption('tw_hashtags') == "" ? "":(' data-hashtags="'.$this->getOption('tw_hashtags').'"');
		
		$this->fb_width = $this->getOption('fb_width') == "" ? '110' : $this->getOption('fb_width');
		$this->fb_height = $this->getOption('fb_height') == "" ? '20' : $this->getOption('fb_height');
		$this->fb_data = ' data-send="false" data_show_faces="false"';
		$this->fb_data .= ' data-layout="'.$this->getOption('fb_layout').'"';
		$this->fb_data .= ' data-width="'.$this->fb_width.'"';
		$this->fb_data .= ' data-action="'.$this->getOption('fb_action').'"';
		$this->fb_data .= ' data-colorscheme="'.$this->getOption('fb_colorscheme').'"';
		$this->gp_data = $this->getOption('gp_size') == "standard" ? '' : (' data-size="'.$this->getOption('gp_size').'"');
		$this->gp_data .= $this->getOption('gp_annotation') == "bubble" ? '' : (' data-annotation="'.$this->getOption('gp_annotation').'"');
		$this->gp_data .= ( $this->getOption('gp_annotation') != "inline" || $this->getOption('gp_width') == "" )  ? '' : (' data-width="'.$this->getOption('gp_width').'"');

	}

	function doSkinVar($skin,$param='twitter') {
		if( $param == 'twitter' ){
				echo  '<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src="//platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document,"script","twitter-wjs");</script>';
		}else if( $param == 'facebook' ){
				echo '<div id="fb-root"></div> <script>(function(d, s, id) { var js, fjs = d.getElementsByTagName(s)[0]; if (d.getElementById(id)) return; js = d.createElement(s); js.id = id; js.src = "//connect.facebook.net/ja_JP/all.js#xfbml=1"; fjs.parentNode.insertBefore(js, fjs); }(document, "script", "facebook-jssdk"));</script>';
		}else if( $param == 'hatena' ){
				echo '<script type="text/javascript" src="http://b.st-hatena.com/js/bookmark_button.js" charset="utf-8" async="async"></script>';
		}else if( $param == 'googleplus' ){
				echo '<script type="text/javascript"> window.___gcfg = {lang: \'ja\'}; (function() { var po = document.createElement(\'script\'); po.type = \'text/javascript\'; po.async = true; po.src = \'https://apis.google.com/js/plusone.js\'; var s = document.getElementsByTagName(\'script\')[0]; s.parentNode.insertBefore(po, s); })(); </script>';
		}
	}		



	function doTemplateVar(&$item,$param='twitter') {
		global $CONF, $manager,$blog;


		$sns_charset = $this->getOption('sns_charset');
		$sns_title_separator = $this->getOption('sns_title_separator');

		$itemid = $this->index_itemid;
		$sns_item_title = $this->index_item_title;
		$sns_blog_name = $blog->getName();
		$sns_item_url = createItemLink($itemid);
		if( strpos($sns_item_url, 'http') === FALSE ){
			$CONF['ItemURL'] = $blog->getURL();
			$sns_item_url = createItemLink($itemid);
		}
		
		$sns_data = $sns_item_title . $sns_title_separator . $sns_blog_name;


		if( $param == "twitter" ){
			$sns_button ='<a href="https://twitter.com/share" class="twitter-share-button" data-url="'.$sns_item_url.'" data-text="'.$sns_data.'" data-lang="ja" '.$this->tw_data.'">Tweet</a>'."\n";
		} else if ( $param == "facebook" ){
			$sns_button = '<div class="fb-like" data-href="'.$sns_item_url.'"'.$this->fb_data.'></div>';
		} else if ( $param == "hatena" ){
				$sns_button='<a href="http://b.hatena.ne.jp/entry/'.$sns_item_url.'" class="hatena-bookmark-button" data-hatena-bookmark-title="'.$sns_data.'"data-hatena-bookmark-layout="'.$this->getOption('hb_layout') .'"title="このエントリーをはてなブックマークに追加"><img src="http://b.st-hatena.com/images/entry-button/button-only.gif" alt="このエントリーをはてなブックマークに追加" width="20" height="20" style="border: none;" /></a>'."\n";
		} else if ( $param == "googleplus" ){
				$sns_button = '<div class="g-plusone" '.$this->gp_data.'" data-href="'.$sns_item_url.'"></div>'."\n";
		}
		

		echo $sns_button;

	}
}
?>	
